Pop_AnimateText
{
	parent_type = /obj
	icon_state = "blank"
	var
	{
		_mapText;

		// Default text style
		_textStyle = "<font style=\"font-family: Impact; font-size:28pt;font-style:italic;font-weight:500;color:white\">"

		_animationType = "FloatFadeUp"
		_animationTime = 8
		_animationDistance = 60
	}
	New()
	{
		maptext_width = 1000
		maptext_height = 100
		layer = EFFECTS_LAYER
		..()
	}

	proc
	{
		//
		// Provide the html style information.
		// Note: Don't include closing tags otherwise it may not work
		// as expected. I'm cheating by not closing out the html tags
		// used in the markup. If you need closing tags, you'll need to mess
		// with things a bit.
		//
		SetTextStyle(var/textStyle)
		{
			_textStyle = textStyle;
		}

		//
		// You can store the value here before calling SpawnText or pass it in with the SpawnText call.
		//
		SetText(var/t)
		{
			_mapText = t
		}

		//
		// Override the default animationTime
		//
		SetAnimationTime(var/t)
		{
			_animationTime = t
		}

		//
		// Override the default animation type
		//
		SetAnimationType(var/t)
		{
			_animationType = t
		}

		//
		// Animates text in a variety of ways.
		// You can override default values
		// You can set values by passing them in or by calling the specific setter methods
		//
		SpawnText(var/animationType = "FloatFadeUp", var/textToAnimate = _mapText, var/textStyle = _textStyle, var/animationTime = _animationTime, var/animationType = _animationType, var/animationDistance = _animationDistance)
		{
			// Overrides or uses defaults
			_mapText = textToAnimate;
			_animationTime = animationTime;
			_animationType = animationType;
			_animationDistance = animationDistance;
			loc = locate(1,1,1)
			filters = filter(type="drop_shadow", size=2, offset=2)
			filters += filter(type="outline", size=1)
			if (_animationType == "FloatFadeUp")
			{
				maptext = "[_textStyle]+[_mapText]"
				animate(src, pixel_y = pixel_y + _animationDistance, time = _animationTime, alpha = 0, easing = SINE_EASING)

				spawn(10)
				{
					del(src)
				}
			}
		}
	}
}

